package sample;

public class PositioningBridge implements AutoCloseable
{
    static { System.loadLibrary("Component_positioningBridge"); }
    
    private long posRef;
    
    public static class Point2D
    {
    	public int latitude;
    	public int longitude;
    	public int accuracy;
    	
    	public Point2D(int latitude, int longitude, int accuracy)
    	{
    		this.latitude = latitude;
    		this.longitude = longitude;
    		this.accuracy = accuracy;
    	}
    }
    
    public PositioningBridge()
    {
    	posRef = start();
    }
    
    /**
     * Close connection to the positioning service
     */
    @Override
    public void close()
    {
        if (posRef != 0)
        {
            stop(posRef);
            posRef = 0;
        }
    }

    public native Point2D Get2DLocation();
    
    private static native long start();
    private static native void stop(long ref);
}
