/**
 * Sample SMS bridge for sending text messages from Java
 *
 * Copyright (C) Sierra Wireless Inc.
 */

#include <legato.h>
#include <interfaces.h>
#include <sample_SmsBridge.h>

JNIEXPORT jboolean JNICALL Java_sample_SmsBridge_SendText
  (JNIEnv *jniEnv, jclass class, jstring javaPhoneNumber, jstring javaText)
{
    const char *phoneNumber = (*jniEnv)->GetStringUTFChars(jniEnv, javaPhoneNumber, NULL);
    const char *text = (*jniEnv)->GetStringUTFChars(jniEnv, javaText, NULL);

    le_sms_MsgRef_t msgRef = le_sms_Create();

    if (le_sms_SetTimeout(msgRef, 5) != LE_OK)
    {
        le_sms_Delete(msgRef);
        return false;
    }

    if (le_sms_SetDestination(msgRef, phoneNumber) != LE_OK)
    {
        le_sms_Delete(msgRef);
        return false;
    }

    if (le_sms_SetText(msgRef, text) != LE_OK)
    {
        le_sms_Delete(msgRef);
        return false;
    }

    if (le_sms_Send(msgRef) != LE_OK)
    {
        le_sms_Delete(msgRef);
        return false;
    }

    le_sms_Delete(msgRef);
    return true;
}

COMPONENT_INIT
{
}
